Revit编程修改板的边界转

来源:互联网 发布:仿真分析软件 matlab 编辑:程序博客网 时间:2024/06/08 06:11

Revit didn’t expose the API to edit floors/slabs boundary by now. Here introduce a trick to edit the boundary.

For a Revit slab or floor, there are mapping model lines to representing the boundary of tha slab. If a floor boundary has 6 segments, there are 6 corresponding model lines for this floor. When we change those model line's position or shape, the slab or floor's shape will be updated accordingly.

There probably are many model lines in a document. How can we find the model lines that representing the slab is the key point.

Here is the solution: You need to create a tempt transaction. During this temp transaction, delete the target slab by Document.Delete() method. This method will return all the deleted elements' ids after the slab is deleted. So the slab's boundary model line can be find by iterating all the return id (get the element from those ids and compare the object type if they are ModelLine class). Finally abort this temp transaction.

After get the boundary's boundary model lines, you can change the model line's shape by changing those ModelLine object ( use this method

LocationCurve lCurve = modelLine.Location as LocationCurve; 
lCurve.Curve = newcurve.

I just did a very quick test, this works. 
  
Here is the complete command code. 
For simplicity, it just moves the floor by creating new boundary lines by moving the old segment.  Here suppose the segment lines are all straight lines.

[Autodesk.Revit.Attributes.Transaction(

          Autodesk.Revit.Attributes.TransactionMode.Manual)]

        public class ChangeFloor : IExternalCommand

        {

          public Autodesk.Revit.UI.Result Execute(

            ExternalCommandData commandData,

            ref string message,

            ElementSet elements)

          {

            Document doc = commandData.Application.ActiveUIDocument.Document;

            Autodesk.Revit.UI.Selection.Selection sel =

              commandData.Application.ActiveUIDocument.Selection;

 

            Reference ref1 = sel.PickObject (Autodesk.Revit.UI.Selection.ObjectType.Element,

              "Please pick a floor to edit");

            Floor f = doc.GetElement(ref1) as Floor;

 

            Transaction transTemp = new Transaction(doc);

            transTemp.Start ("tempDelete");

            ICollection<ElementId> ids = doc.Delete(f);

            transTemp.RollBack ();

 

            List<ModelLine> mLines = new List<ModelLine>();

            foreach (ElementId id in ids)

            {

              Element ele = doc.GetElement (id);

              if (ele is ModelLine)

              {

                mLines.Add(ele as ModelLine);

              }加盟网www.30jm.com加盟网

            }

 

            Transaction trans = new Transaction(doc);

            trans.Start("ChangeFloor");

 

            //

            foreach (ModelLine mline in mLines)

            {

              LocationCurve lCurve = mline.Location as LocationCurve;

              Line c = lCurve.Curve as Line;

              XYZ pt1 = c.GetEndPoint(0);

              XYZ pt2 = c.GetEndPoint(1);

 

              Transform transform = Transform.CreateTranslation(

                new XYZ(1, 1, 0)); //move the line.

              XYZ pt1New = transform.OfPoint (pt1);

              XYZ pt2New = transform.OfPoint (pt2);

              Line newLine = Line.CreateBound(pt1New, pt2New);

              lCurve.Curve = newLine;

 

            }

            trans.Commit ();

            return Result.Succeeded;

          }

        }

 

    }

0 0
原创粉丝点击